local db
local rolls = {}
local rollers = {}
local rolling = false
local item

-- local function addon_loaded()
--     print('a')
-- end

-- local function entering_world()
    
-- end

-- local function save_variables()
    
-- end

local function clear_rollers()
    for k,v in pairs(rolls) do
        rolls[k] = nil
    end
    for k,v in pairs(rollers) do
        rollers[k] = nil
    end
end

local function getRank()
    local nameP = GetUnitName("PLAYER", false)
    for i = 1, GetNumGroupMembers() do
        local name, rank = GetRaidRosterInfo(i)
        if nameP == name then
            return rank
        end
    end
end

local function group_type()
    if IsInRaid() and getRank() > 0 then
        return "RAID_WARNING"
    elseif IsInRaid() then
        return "RAID"
    elseif IsInGroup() then
        return "PARTY"
    else
        return nil
    end
end

local function who_won()
    if rolling then
        local gt = group_type();
        if #rolls > 0 then
            if gt then
                SendChatMessage(rolls[1][1] .. ' won ' .. item .. ' with a ' .. rolls[1][2] .. '!', gt)
            end
        else
            if gt then
                SendChatMessage('Rolling for ' .. item .. ' was stopped before anyone could roll.', gt)
            end
        end
    end
    rolling = false
end

local frame = CreateFrame("Frame", nil, UIParent)
frame:SetFrameStrata("BACKGROUND")
frame:SetWidth(350)
frame:SetHeight(500)
frame:SetAlpha(1)
frame:SetMovable(true)
frame:EnableMouse(true)
frame:RegisterForDrag("LeftButton")
frame:SetScript("OnDragStart", frame.StartMoving)
frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
frame:SetScript("OnMouseDown", function(self, button)
    if button == "LeftButton" and not self.isMoving then
        self:StartMoving();
        self.isMoving = true;
    end
end)
frame:SetScript("OnMouseUp", function(self, button)
    if button == "LeftButton" and self.isMoving then
        self:StopMovingOrSizing();
        self.isMoving = false;
    end
end)
frame:SetScript("OnHide", function(self)
    if ( self.isMoving ) then
        self:StopMovingOrSizing();
        self.isMoving = false;
    end
end)
frame:SetPoint("LEFT", 0, 0)
frame:SetBackdropColor(0, 0, 0, 1)
frame:SetBackdrop({bgFile = "Interface/FrameGeneral/UI-Background-Marble", edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true, tileSize = 500, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }})
frame.text = frame:CreateFontString('ItemName', "ARTWORK") 
frame.text:SetFont("Fonts\\ARIALN.ttf", 20, "OUTLINE")
frame.text:SetPoint("TOP", 0, -5)
frame.text2 = frame:CreateFontString('Rolls') 
frame.text2:SetFont("Fonts\\ARIALN.ttf", 16)
frame.text2:SetPoint("TOPLEFT", 15, -50)
frame.text2:SetJustifyH("LEFT")
frame.text2:SetJustifyV("TOP")
frame.text3 = frame:CreateFontString('Credits') 
frame.text3:SetFont("Fonts\\ARIALN.ttf", 10)
frame.text3:SetPoint("BOTTOM", 0, 12)
frame.text3:SetText('Made by |cff00FF96Sukari - Zul\'jin (EU)')
frame:Hide()
local b = CreateFrame("BUTTON", nil, frame, "SecureHandlerClickTemplate")
b:SetSize(32,32)
b:SetPoint("TOPRIGHT",0,0)
b:RegisterForClicks("AnyUp")
b:SetNormalTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Up")
b:SetPushedTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Down")
b:SetHighlightTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Highlight")
b:SetScript("OnClick", function(self) 
    frame:Hide()
    frame.text2:SetText('')
    who_won()
    clear_rollers()
end)
local b = CreateFrame("Button", "MyButton", frame, "UIPanelButtonTemplate")
b:SetSize(80 ,22) -- width, height
b:SetText("Stop")
b:SetPoint("BOTTOM", 0, 25)
b:SetScript("OnClick", function()
    who_won()
end)



SLASH_ITEMROLLING1 = "/ir"
SlashCmdList["ITEMROLLING"] = function(msg)
    local arg1, arg2 = strsplit(" ", msg, 2)
    if arg1 == 'r' and arg2 ~= nil then
        rolling = true
        item = arg2
        if rolling then
            frame.text2:SetText('')
            clear_rollers()
        end
        if(group_type()) then
            SendChatMessage('Rolling for ' .. arg2 .. ' starts now!', group_type())
        end
        frame.text:SetText(arg2)
        frame:Show()
    elseif arg1 == 'c' then
        frame:Hide()
        frame.text2:SetText('')
        who_won()
        clear_rollers()
    elseif arg1 == 's' then
        who_won()
    elseif arg1 == 'h' then
        print('|cff00FF96ItemRoller:\n|cFFFFFFFFType "/ir r [itemlink | itemname]" to start rolling for an item.\nType "/ir c to close the rolling window and stop rolling an item.\nType "/ir s" to stop rolling an item.')
    else
        print('|cff00FF96ItemRoller: |cFFFFFFFFType "/ir h" to get the list of commands for ItemRoller')
    end
end

local function create_rolling_list()
    table.sort(rolls, function(a, b) return a[2] > b[2] end)

    local text = ''
    local first = true
    for i, value in pairs(rolls) do
        if first then
            text = '|cFF00FF00' .. i .. '. ' .. text .. value[1] .. ' ' .. value[2]  .. ' / 100' .. '|cFFFFFFFF\n'
            first = false
        else
            text = text .. i .. '. ' .. value[1] .. ' ' .. value[2]  .. ' / 100' .. '\n'
        end
    end
    frame.text2:SetText(text)
end

local function chat_men(roll, author)
    table.insert(rolls, {author, roll})
    rollers[author] = true
    create_rolling_list()
end

local frameEv = _G.CreateFrame('FRAME')
frameEv:RegisterEvent('ADDON_LOADED')
frameEv:RegisterEvent('PLAYER_ENTERING_WORLD')
frameEv:RegisterEvent('CHAT_MSG_SYSTEM')
frameEv:RegisterEvent('PLAYER_LEAVING_WORLD')

frameEv:SetScript('OnEvent', function(self, event, ...)
    -- if event == 'ADDON_LOADED' then
    --     if arg1 == 'NameCopy' then
    --         -- addon_loaded()
    --     end
    -- elseif event == 'PLAYER_ENTERING_WORLD' then
    --     -- entering_world()
    --     -- save_variables()
    -- elseif event == 'PLAYER_LEAVING_WORLD' then
    --     -- save_variables()
    -- else
    if event == 'CHAT_MSG_SYSTEM' then
        local message = ...
        local author, rollResult, rollMin, rollMax = string.match(message, "(.+) %w* (%d+) %((%d+)-(%d+)%)")
        if author and rolling then
            author = strsplit(' ', author, 2)
            if rollMax == '100' and rollMin == '1' and rollers[author] == nil then
                chat_men(rollResult, author)
            end
        end
    end
end)